/* Generated automatically by the program `genpeep'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "tree.h"
#include "rtl.h"
#include "insn-config.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "regs.h"
#include "output.h"
#include "recog.h"
#include "except.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "tm-constrs.h"

extern rtx peep_operand[];

#define operands peep_operand

rtx_insn *
peephole (rtx_insn *ins1)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;
  rtx x ATTRIBUTE_UNUSED, pat ATTRIBUTE_UNUSED;

  if (NEXT_INSN (ins1)
      && BARRIER_P (NEXT_INSN (ins1)))
    return 0;

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1575;
  if (XVECLEN (x, 0) != 2) goto L1575;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1575;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  operands[0] = x;
  if (! d_register_operand (x, SImode)) goto L1575;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != PLUS) goto L1575;
  if (GET_MODE (x) != SImode) goto L1575;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1575;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1575;
  if (XWINT (x, 0) != -1) goto L1575;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1575;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  if (GET_CODE (x) != SCRATCH) goto L1575;
  if (GET_MODE (x) != QImode) goto L1575;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1575; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1575;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1575;
  if (XVECLEN (x, 0) != 2) goto L1575;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1575;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1575;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1575;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1575;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1575;
  if (XWINT (x, 0) != -1) goto L1575;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1575;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1575;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1575; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1575;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1575;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1575;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1575;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1575;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1575;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1575;
  if (XWINT (x, 0) != 0) goto L1575;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1575;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1575;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1575;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1575:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1576;
  if (XVECLEN (x, 0) != 2) goto L1576;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1576;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  operands[0] = x;
  if (! d_register_operand (x, SImode)) goto L1576;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != PLUS) goto L1576;
  if (GET_MODE (x) != SImode) goto L1576;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1576;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1576;
  if (XWINT (x, 0) != -1) goto L1576;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1576;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  if (GET_CODE (x) != SCRATCH) goto L1576;
  if (GET_MODE (x) != QImode) goto L1576;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1576; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1576;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1576;
  if (XVECLEN (x, 0) != 2) goto L1576;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1576;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1576;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1576;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1576;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1576;
  if (XWINT (x, 0) != -1) goto L1576;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1576;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1576;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1576; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1576;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1576;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1576;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1576;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1576;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1576;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1576;
  if (XWINT (x, 0) != 0) goto L1576;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1576;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1576;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1576;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1576:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1577;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! d_register_operand (x, HImode)) goto L1577;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L1577;
  if (GET_MODE (x) != HImode) goto L1577;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1577;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1577;
  if (XWINT (x, 0) != -1) goto L1577;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1577; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1577;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1577;
  if (XVECLEN (x, 0) != 2) goto L1577;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1577;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1577;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1577;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1577;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1577;
  if (XWINT (x, 0) != -1) goto L1577;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1577;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1577;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1577; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1577;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1577;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1577;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1577;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1577;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1577;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1577;
  if (XWINT (x, 0) != 0) goto L1577;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1577;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1577;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1577;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1577:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1578;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! d_register_operand (x, HImode)) goto L1578;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L1578;
  if (GET_MODE (x) != HImode) goto L1578;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1578;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1578;
  if (XWINT (x, 0) != -1) goto L1578;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1578; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1578;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1578;
  if (XVECLEN (x, 0) != 2) goto L1578;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1578;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1578;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1578;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1578;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1578;
  if (XWINT (x, 0) != -1) goto L1578;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1578;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1578;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1578; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1578;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1578;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1578;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1578;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1578;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1578;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1578;
  if (XWINT (x, 0) != 0) goto L1578;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1578;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1578;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1578;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1578:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1579;
  if (XVECLEN (x, 0) != 2) goto L1579;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1579;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  operands[0] = x;
  if (! d_register_operand (x, HImode)) goto L1579;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != PLUS) goto L1579;
  if (GET_MODE (x) != HImode) goto L1579;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1579;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1579;
  if (XWINT (x, 0) != -1) goto L1579;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1579;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  if (GET_CODE (x) != SCRATCH) goto L1579;
  if (GET_MODE (x) != QImode) goto L1579;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1579; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1579;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1579;
  if (XVECLEN (x, 0) != 2) goto L1579;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1579;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1579;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1579;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1579;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1579;
  if (XWINT (x, 0) != -1) goto L1579;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1579;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1579;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1579; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1579;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1579;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1579;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1579;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1579;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1579;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1579;
  if (XWINT (x, 0) != 0) goto L1579;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1579;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1579;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1579;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1579:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1580;
  if (XVECLEN (x, 0) != 2) goto L1580;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1580;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  operands[0] = x;
  if (! d_register_operand (x, HImode)) goto L1580;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != PLUS) goto L1580;
  if (GET_MODE (x) != HImode) goto L1580;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1580;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1580;
  if (XWINT (x, 0) != -1) goto L1580;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1580;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  if (GET_CODE (x) != SCRATCH) goto L1580;
  if (GET_MODE (x) != QImode) goto L1580;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1580; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1580;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1580;
  if (XVECLEN (x, 0) != 2) goto L1580;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1580;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1580;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1580;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1580;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1580;
  if (XWINT (x, 0) != -1) goto L1580;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1580;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1580;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1580; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1580;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1580;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1580;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1580;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1580;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1580;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1580;
  if (XWINT (x, 0) != 0) goto L1580;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1580;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1580;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1580;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1580:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1581;
  if (XVECLEN (x, 0) != 2) goto L1581;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1581;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  operands[0] = x;
  if (! l_register_operand (x, HImode)) goto L1581;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != PLUS) goto L1581;
  if (GET_MODE (x) != HImode) goto L1581;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1581;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1581;
  if (XWINT (x, 0) != -1) goto L1581;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1581;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[3] = x;
  if (! d_register_operand (x, QImode)) goto L1581;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1581; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1581;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1581;
  if (XVECLEN (x, 0) != 2) goto L1581;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1581;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1581;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1581;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1581;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1581;
  if (XWINT (x, 0) != -1) goto L1581;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1581;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1581;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1581; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1581;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1581;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1581;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1581;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1581;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1581;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1581;
  if (XWINT (x, 0) != 0) goto L1581;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1581;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1581;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 1581;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1581:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1582;
  if (XVECLEN (x, 0) != 2) goto L1582;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1582;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  operands[0] = x;
  if (! l_register_operand (x, HImode)) goto L1582;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != PLUS) goto L1582;
  if (GET_MODE (x) != HImode) goto L1582;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1582;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1582;
  if (XWINT (x, 0) != -1) goto L1582;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1582;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[3] = x;
  if (! d_register_operand (x, QImode)) goto L1582;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1582; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1582;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != PARALLEL) goto L1582;
  if (XVECLEN (x, 0) != 2) goto L1582;
  x = XVECEXP (pat, 0, 0);
  if (GET_CODE (x) != SET) goto L1582;
  x = XEXP (XVECEXP (pat, 0, 0), 0);
  if (GET_CODE (x) != CC0) goto L1582;
  x = XEXP (XVECEXP (pat, 0, 0), 1);
  if (GET_CODE (x) != COMPARE) goto L1582;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1582;
  x = XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1582;
  if (XWINT (x, 0) != -1) goto L1582;
  x = XVECEXP (pat, 0, 1);
  if (GET_CODE (x) != CLOBBER) goto L1582;
  x = XEXP (XVECEXP (pat, 0, 1), 0);
  operands[1] = x;
  if (! d_register_operand (x, QImode)) goto L1582;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1582; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1582;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1582;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1582;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1582;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1582;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1582;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1582;
  if (XWINT (x, 0) != 0) goto L1582;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1582;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[2] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1582;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 1582;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1582:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1583;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! d_register_operand (x, QImode)) goto L1583;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L1583;
  if (GET_MODE (x) != QImode) goto L1583;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1583;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1583;
  if (XWINT (x, 0) != -1) goto L1583;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1583; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1583;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1583;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1583;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1583;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1583;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1583;
  if (XWINT (x, 0) != -1) goto L1583;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1583; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1583;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1583;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1583;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1583;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1583;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1583;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1583;
  if (XWINT (x, 0) != 0) goto L1583;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1583;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[1] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1583;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (2, operands));
  INSN_CODE (ins1) = 1583;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1583:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1584;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! d_register_operand (x, QImode)) goto L1584;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L1584;
  if (GET_MODE (x) != QImode) goto L1584;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1584;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1584;
  if (XWINT (x, 0) != -1) goto L1584;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1584; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1584;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1584;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1584;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1584;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L1584;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L1584;
  if (XWINT (x, 0) != -1) goto L1584;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1584; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1584;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1584;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1584;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1584;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1584;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1584;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1584;
  if (XWINT (x, 0) != 0) goto L1584;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1584;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[1] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1584;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (2, operands));
  INSN_CODE (ins1) = 1584;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1584:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1585;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1585;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1585;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! register_operand (x, QImode)) goto L1585;
  x = XEXP (XEXP (pat, 1), 1);
  operands[2] = x;
  if (! reg_or_0_operand (x, QImode)) goto L1585;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1585; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1585;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1585;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1585;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1585;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1585;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1585;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1585;
  if (XWINT (x, 0) != 0) goto L1585;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1585;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[0] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1585;
  if (! (jump_over_one_insn_p (insn, operands[0]))) goto L1585;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1585;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1585:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1586;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1586;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1586;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! register_operand (x, QQmode)) goto L1586;
  x = XEXP (XEXP (pat, 1), 1);
  operands[2] = x;
  if (! reg_or_0_operand (x, QQmode)) goto L1586;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1586; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1586;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1586;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1586;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1586;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1586;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1586;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1586;
  if (XWINT (x, 0) != 0) goto L1586;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1586;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[0] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1586;
  if (! (jump_over_one_insn_p (insn, operands[0]))) goto L1586;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1586;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1586:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1587;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1587;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1587;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! register_operand (x, UQQmode)) goto L1587;
  x = XEXP (XEXP (pat, 1), 1);
  operands[2] = x;
  if (! reg_or_0_operand (x, UQQmode)) goto L1587;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1587; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1587;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1587;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1587;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1587;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != EQ) goto L1587;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1587;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1587;
  if (XWINT (x, 0) != 0) goto L1587;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1587;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[0] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1587;
  if (! (jump_over_one_insn_p (insn, operands[0]))) goto L1587;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1587;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1587:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1588;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1588;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1588;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! register_operand (x, QImode)) goto L1588;
  x = XEXP (XEXP (pat, 1), 1);
  operands[2] = x;
  if (! reg_or_0_operand (x, QImode)) goto L1588;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1588; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1588;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1588;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1588;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1588;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1588;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1588;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1588;
  if (XWINT (x, 0) != 0) goto L1588;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1588;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[0] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1588;
  if (! (!AVR_HAVE_JMP_CALL
   || !TARGET_SKIP_BUG)) goto L1588;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1588;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1588:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1589;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1589;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1589;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! register_operand (x, QQmode)) goto L1589;
  x = XEXP (XEXP (pat, 1), 1);
  operands[2] = x;
  if (! reg_or_0_operand (x, QQmode)) goto L1589;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1589; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1589;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1589;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1589;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1589;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1589;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1589;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1589;
  if (XWINT (x, 0) != 0) goto L1589;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1589;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[0] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1589;
  if (! (!AVR_HAVE_JMP_CALL
   || !TARGET_SKIP_BUG)) goto L1589;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1589;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1589:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1590;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != CC0) goto L1590;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != COMPARE) goto L1590;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! register_operand (x, UQQmode)) goto L1590;
  x = XEXP (XEXP (pat, 1), 1);
  operands[2] = x;
  if (! reg_or_0_operand (x, UQQmode)) goto L1590;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L1590; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L1590;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L1590;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != PC) goto L1590;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != IF_THEN_ELSE) goto L1590;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != NE) goto L1590;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (GET_CODE (x) != CC0) goto L1590;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (GET_CODE (x) != CONST_INT) goto L1590;
  if (XWINT (x, 0) != 0) goto L1590;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != LABEL_REF) goto L1590;
  x = XEXP (XEXP (XEXP (pat, 1), 1), 0);
  operands[0] = x;
  x = XEXP (XEXP (pat, 1), 2);
  if (GET_CODE (x) != PC) goto L1590;
  if (! (!AVR_HAVE_JMP_CALL
   || !TARGET_SKIP_BUG)) goto L1590;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 1590;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L1590:

  return 0;
}

rtx peep_operand[4];
