/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-11.3.0/gcc/config/avr/avr.md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "emit-rtl.h"
#include "tm-constrs.h"
#include "target.h"

int
l_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 23 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(REGNO (op) <= 15))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
d_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 28 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(REGNO (op) >= 16 && REGNO (op) <= 31))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
even_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 32 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(REGNO (op) <= 31)) && (
#line 33 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
((REGNO (op) & 1) == 0)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
odd_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 37 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(REGNO (op) <= 31)) && (
#line 38 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
((REGNO (op) & 1) != 0)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
stack_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 43 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(REGNO (op) == REG_SP))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
low_io_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_INT) && (
#line 48 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op) - avr_arch->sfr_offset,
				   0, 0x1F)))) || ((GET_CODE (op) == SYMBOL_REF) && (
#line 51 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(SYMBOL_REF_FLAGS (op) & SYMBOL_FLAG_IO_LOW)));
}

int
high_io_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 56 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op) - avr_arch->sfr_offset,
                              0x20, 0x3F)));
}

int
io_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_INT) && (
#line 62 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op) - avr_arch->sfr_offset,
				   0, 0x3F)))) || ((GET_CODE (op) == SYMBOL_REF) && (
#line 65 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(SYMBOL_REF_FLAGS (op) & SYMBOL_FLAG_IO)));
}

int
nop_general_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (general_operand (op, mode)) && (
#line 70 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(!avr_mem_flash_p (op)));
}

int
nox_general_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (general_operand (op, mode)) && ((!(
#line 76 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(avr_load_libgcc_p (op)))) && (!(
#line 77 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(avr_mem_memx_p (op)))));
}

int
const0_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      break;
    default:
      return false;
    }
  return (
#line 82 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(op == CONST0_RTX (mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
const1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 87 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(op == CONST1_RTX (mode)));
}

int
const_0_to_7_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 93 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), 0, 7)));
}

int
const_2_to_7_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 98 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), 2, 7)));
}

int
const_1_to_6_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 103 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), 1, 6)));
}

int
const_2_to_6_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 108 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), 2, 6)));
}

int
const_m255_to_m1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 113 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), -255, -1)));
}

int
reg_or_0_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const0_operand (op, mode));
}

int
symbol_ref_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == SYMBOL_REF) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
text_segment_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 128 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
{
  switch (GET_CODE (op))
    {
    case CODE_LABEL:
      return true;
    case LABEL_REF :
      return true;
    case SYMBOL_REF :
      return SYMBOL_REF_FUNCTION_P (op);
    case PLUS :
      /* Assume canonical format of symbol + constant.
	 Fall through.  */
    case CONST :
      return text_segment_operand (XEXP (op, 0), VOIDmode);
    default :
      return false;
    }
}

int
text_segment_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CODE_LABEL:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case CONST:
      break;
    default:
      return false;
    }
  return (
(text_segment_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
single_one_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 151 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(exact_log2(INTVAL (op) & GET_MODE_MASK (mode)) >= 0));
}

int
single_zero_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 157 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(exact_log2(~INTVAL (op) & GET_MODE_MASK (mode)) >= 0));
}

int
avr_sp_immediate_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 162 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(satisfies_constraint_Csp (op)));
}

int
eqne_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
gelt_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case GE:
    case LT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
difficult_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case GT:
    case GTU:
    case LE:
    case LEU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
simple_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (comparison_operator (op, mode)) && (!(GET_CODE (op) == GT || GET_CODE (op) == GTU || GET_CODE (op) == LE || GET_CODE (op) == LEU));
}

int
extend_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
call_insn_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && ((
#line 188 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(register_operand (XEXP (op, 0), mode))) || (
#line 189 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(CONSTANT_ADDRESS_P (XEXP (op, 0)))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
pseudo_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (!((GET_CODE (op) == REG) && (
#line 200 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(HARD_REGISTER_P (op)))));
}

int
pseudo_register_or_const_int_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_int_operand (op, mode)) || (pseudo_register_operand (op, mode));
}

int
combine_pseudo_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (pseudo_register_operand (op, mode)) || ((register_operand (op, mode)) && (
#line 218 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(reload_completed || reload_in_progress)));
}

int
const_8_16_24_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 224 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(INTVAL(op) == 8 || INTVAL(op) == 16 || INTVAL(op) == 24));
}

int
u8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 229 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), 0, 255)));
}

int
s8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 234 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), -128, 127)));
}

int
o8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 239 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), -256, -1)));
}

int
s9_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 244 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), -256, 255)));
}

int
register_or_s9_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (s9_operand (op, mode));
}

int
u16_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 253 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), 0, (1<<16)-1)));
}

int
s16_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 258 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), -(1<<15), (1<<15)-1)));
}

int
o16_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 263 "../../gcc-11.3.0/gcc/config/avr/predicates.md"
(IN_RANGE (INTVAL (op), -(1<<16), -1)));
}

int
const_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_FIXED) || ((GET_CODE (op) == CONST_DOUBLE) || (const_int_operand (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
nonmemory_or_const_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_FIXED) || ((GET_CODE (op) == CONST_DOUBLE) || (nonmemory_operand (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
const_or_immediate_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_FIXED) || ((GET_CODE (op) == CONST_DOUBLE) || (immediate_operand (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

enum constraint_num
lookup_constraint_1 (const char *str)
{
  switch (str[0])
    {
    case '<':
      return CONSTRAINT__l;
    case '>':
      return CONSTRAINT__g;
    case 'C':
      if (!strncmp (str + 1, "03", 2))
        return CONSTRAINT_C03;
      if (!strncmp (str + 1, "04", 2))
        return CONSTRAINT_C04;
      if (!strncmp (str + 1, "05", 2))
        return CONSTRAINT_C05;
      if (!strncmp (str + 1, "06", 2))
        return CONSTRAINT_C06;
      if (!strncmp (str + 1, "07", 2))
        return CONSTRAINT_C07;
      if (!strncmp (str + 1, "a1", 2))
        return CONSTRAINT_Ca1;
      if (!strncmp (str + 1, "a2", 2))
        return CONSTRAINT_Ca2;
      if (!strncmp (str + 1, "a3", 2))
        return CONSTRAINT_Ca3;
      if (!strncmp (str + 1, "a4", 2))
        return CONSTRAINT_Ca4;
      if (!strncmp (str + 1, "o1", 2))
        return CONSTRAINT_Co1;
      if (!strncmp (str + 1, "o2", 2))
        return CONSTRAINT_Co2;
      if (!strncmp (str + 1, "o3", 2))
        return CONSTRAINT_Co3;
      if (!strncmp (str + 1, "o4", 2))
        return CONSTRAINT_Co4;
      if (!strncmp (str + 1, "x2", 2))
        return CONSTRAINT_Cx2;
      if (!strncmp (str + 1, "x3", 2))
        return CONSTRAINT_Cx3;
      if (!strncmp (str + 1, "x4", 2))
        return CONSTRAINT_Cx4;
      if (!strncmp (str + 1, "sp", 2))
        return CONSTRAINT_Csp;
      if (!strncmp (str + 1, "xf", 2))
        return CONSTRAINT_Cxf;
      if (!strncmp (str + 1, "0f", 2))
        return CONSTRAINT_C0f;
      if (!strncmp (str + 1, "n8", 2))
        return CONSTRAINT_Cn8;
      if (!strncmp (str + 1, "m2", 2))
        return CONSTRAINT_Cm2;
      break;
    case 'E':
      return CONSTRAINT_E;
    case 'F':
      return CONSTRAINT_F;
    case 'G':
      return CONSTRAINT_G;
    case 'I':
      return CONSTRAINT_I;
    case 'J':
      return CONSTRAINT_J;
    case 'K':
      return CONSTRAINT_K;
    case 'L':
      return CONSTRAINT_L;
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      return CONSTRAINT_N;
    case 'O':
      return CONSTRAINT_O;
    case 'P':
      return CONSTRAINT_P;
    case 'Q':
      return CONSTRAINT_Q;
    case 'V':
      return CONSTRAINT_V;
    case 'X':
      return CONSTRAINT_X;
    case 'Y':
      if (!strncmp (str + 1, "00", 2))
        return CONSTRAINT_Y00;
      if (!strncmp (str + 1, "01", 2))
        return CONSTRAINT_Y01;
      if (!strncmp (str + 1, "m1", 2))
        return CONSTRAINT_Ym1;
      if (!strncmp (str + 1, "02", 2))
        return CONSTRAINT_Y02;
      if (!strncmp (str + 1, "m2", 2))
        return CONSTRAINT_Ym2;
      if (!strncmp (str + 1, "x2", 2))
        return CONSTRAINT_Yx2;
      if (!strncmp (str + 1, "IJ", 2))
        return CONSTRAINT_YIJ;
      if (!strncmp (str + 1, "nn", 2))
        return CONSTRAINT_Ynn;
      break;
    case 'a':
      return CONSTRAINT_a;
    case 'b':
      return CONSTRAINT_b;
    case 'd':
      return CONSTRAINT_d;
    case 'e':
      return CONSTRAINT_e;
    case 'i':
      return CONSTRAINT_i;
    case 'l':
      return CONSTRAINT_l;
    case 'm':
      return CONSTRAINT_m;
    case 'n':
      return CONSTRAINT_n;
    case 'o':
      return CONSTRAINT_o;
    case 'p':
      return CONSTRAINT_p;
    case 'q':
      return CONSTRAINT_q;
    case 'r':
      return CONSTRAINT_r;
    case 's':
      return CONSTRAINT_s;
    case 't':
      return CONSTRAINT_t;
    case 'w':
      return CONSTRAINT_w;
    case 'x':
      return CONSTRAINT_x;
    case 'y':
      return CONSTRAINT_y;
    case 'z':
      return CONSTRAINT_z;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

const unsigned char lookup_constraint_array[] = {
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__l, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__g, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_E, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_F, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_G, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_I, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_J, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_K, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_L, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_M, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_N, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_O, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_P, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_Q, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_V, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_X, (int) UCHAR_MAX),
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_a, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_b, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_d, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_e, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_i, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_l, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_m, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_n, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_o, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_p, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_q, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_r, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_s, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_t, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_w, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_x, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_y, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_z, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN
};

enum reg_class
reg_class_for_constraint_1 (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_r: return GENERAL_REGS;
    case CONSTRAINT_t: return R0_REG;
    case CONSTRAINT_b: return BASE_POINTER_REGS;
    case CONSTRAINT_e: return POINTER_REGS;
    case CONSTRAINT_w: return ADDW_REGS;
    case CONSTRAINT_d: return LD_REGS;
    case CONSTRAINT_l: return NO_LD_REGS;
    case CONSTRAINT_a: return SIMPLE_LD_REGS;
    case CONSTRAINT_x: return POINTER_X_REGS;
    case CONSTRAINT_y: return POINTER_Y_REGS;
    case CONSTRAINT_z: return POINTER_Z_REGS;
    case CONSTRAINT_q: return STACK_REG;
    default: break;
    }
  return NO_REGS;
}

bool (*constraint_satisfied_p_array[]) (rtx) = {
  satisfies_constraint_I,
  satisfies_constraint_J,
  satisfies_constraint_K,
  satisfies_constraint_L,
  satisfies_constraint_M,
  satisfies_constraint_N,
  satisfies_constraint_O,
  satisfies_constraint_P,
  satisfies_constraint_m,
  satisfies_constraint_o,
  satisfies_constraint_Q,
  satisfies_constraint_p,
  satisfies_constraint_G,
  satisfies_constraint_Cm2,
  satisfies_constraint_C03,
  satisfies_constraint_C04,
  satisfies_constraint_C05,
  satisfies_constraint_C06,
  satisfies_constraint_C07,
  satisfies_constraint_Ca1,
  satisfies_constraint_Ca2,
  satisfies_constraint_Ca3,
  satisfies_constraint_Ca4,
  satisfies_constraint_Co1,
  satisfies_constraint_Co2,
  satisfies_constraint_Co3,
  satisfies_constraint_Co4,
  satisfies_constraint_Cx2,
  satisfies_constraint_Cx3,
  satisfies_constraint_Cx4,
  satisfies_constraint_Csp,
  satisfies_constraint_Cxf,
  satisfies_constraint_C0f,
  satisfies_constraint_Cn8,
  satisfies_constraint_Ynn,
  satisfies_constraint_Y00,
  satisfies_constraint_Yx2,
  satisfies_constraint_YIJ,
  satisfies_constraint_V,
  satisfies_constraint__l,
  satisfies_constraint__g,
  satisfies_constraint_i,
  satisfies_constraint_s,
  satisfies_constraint_n,
  satisfies_constraint_E,
  satisfies_constraint_F,
  satisfies_constraint_X,
  satisfies_constraint_Y01,
  satisfies_constraint_Ym1,
  satisfies_constraint_Y02,
  satisfies_constraint_Ym2
};

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I:
      return 
#line 59 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival >= 0 && ival <= 63);

    case CONSTRAINT_J:
      return 
#line 64 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival <= 0 && ival >= -63);

    case CONSTRAINT_K:
      return 
#line 69 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival == 2);

    case CONSTRAINT_L:
      return 
#line 74 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival == 0);

    case CONSTRAINT_M:
      return 
#line 79 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival >= 0 && ival <= 0xff);

    case CONSTRAINT_N:
      return 
#line 84 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival == -1);

    case CONSTRAINT_O:
      return 
#line 89 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival == 8 || ival == 16 || ival == 24);

    case CONSTRAINT_P:
      return 
#line 94 "../../gcc-11.3.0/gcc/config/avr/constraints.md"
(ival == 1);

    default: break;
    }
  return false;
}

